package com.loafle.overflow.crawler.result;

import com.loafle.overflow.crawler.config.Item;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * Created by root on 17. 4. 25.
 */
public class OFResultSet {

    private Item item;
    private List<List<String>> rows;
    private Map<String, Integer> meta = null;

    public Map<String, Integer> getMeta() {
        return meta;
    }

    public void setMeta(Map<String, Integer> meta) {
        this.meta = meta;
    }

    public List<List<String>> getRows() {
        return rows;
    }

    public void setRows(List<List<String>> rows) {
        this.rows = rows;
    }

    public Item getItem() {
        return item;
    }

    public void setItem(Item item) {
        this.item = item;
    }


    public void setMeta() {


        String type = (String) this.item.getQuery().getQueryInfo().get("parseDirection");
        List<String> meta = new ArrayList<>();
        if (type.equals("row")) {

            List<String> arrayColumns = (List<String>) this.item.getQuery().getQueryInfo().get("arrayColumns");
            List<String> keyColumns = (List<String>) this.item.getQuery().getQueryInfo().get("keyColumns");
            String valueColumn = (String) this.item.getQuery().getQueryInfo().get("valueColumn");

            for (String c : arrayColumns) {
                meta.add(c);
            }
            for (String c: keyColumns) {
                meta.add(c);
            }
            meta.add(valueColumn);

        } else {

        }


        if(this.meta == null) {
            this.meta = new HashMap<>();
        }

        for(int indexI = 0; indexI < meta.size(); ++indexI) {
            this.meta.put(meta.get(indexI), indexI);
        }

    }

    public OFResultSet(Item item) {
        this.item = item;
        this.rows = new ArrayList<>();
        this.setMeta();
    }

    public void addRow(List<String> row) {
        rows.add(row);
    }


    public Map<String,String> getData() {
        String type = (String) this.item.getQuery().getQueryInfo().get("parseType");
        if (type.equals("row")) {
            return parseRow();
        } else {
            return parseCol();
        }
    }

    public Map<String, String> parseCol() {





        return null;
    }

    public Map<String, String> parseRow() {
        return null;
    }

}
